Subject: [RFC PATCH] builtin-apply: prevent non-explicit permission changes

From: Alexander Potashev <[email-masked]>
Date: Wed, 31 Dec 2008 02:53:57 +0300

Prevent 'git apply' from changing permissions without
'old mode'/'new mode' lines in patch.
(WARNING: this changes the behaviour of 'git apply')

Signed-off-by: Alexander Potashev <[email-masked]>
---

Once upon a time there was a shell script in a Git repository. But that
shell script had 100644 permission (regular file). Then I did
'chmod +x', commit... but the shell script was related to my friend's
stuff in the repository and I received a patch from him regarding the
script. But the patch was against a repository version before
'chmod +x', thus it contained an index line such as the following:

	index fc3c3a4..066a4ac 100644
(it still had '100644' permissions)

I have to note that there was no 'old/new mode' lines. But when I ran
'git am <patch>' it restored '100644' permissions. So, 'git am' changed
my permissions (100755 -> 100644) without any explicit permission
changes in the patch.

I think, 'git apply'/'git am' should apply only _changes_ _mentioned_ in
patch; if there's no 'old mode ...'/'new mode ...' lines in it, 'git
apply' shouldn't change the permissions.

Test cases are probably wanted, but I don't really know how to do them
and I'll only give a chain of commands to reproduce the issue:

	mkdir repo
	cd repo

	git init
	echo "This is a shell script" > script.sh
	git add script.sh
	git ci -m "initial commit"

	echo "a new line and a newline" >> script.sh
	git ci -a -m "only content changes"	# aka patch to apply
	git format-patch -1			# now we have a patch

	git reset --hard HEAD^
	chmod +x script.sh
	git ci -a -m "permission changes"

	git am 0001-only-content-changes.patch
	stat -c %a script.sh			# check the result

'stat' says '644' if 'git am' has changed the permissions or '755' if
it hasn't.

					Alexander

 builtin-apply.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletions(-)

diff --git a/builtin-apply.c b/builtin-apply.c
index 07244b0..071f6d8 100644
--- a/builtin-apply.c
+++ b/builtin-apply.c
@@ -630,7 +630,7 @@ static int gitdiff_index(const char *line, struct patch *patch)
 	memcpy(patch->new_sha1_prefix, line, len);
 	patch->new_sha1_prefix[len] = 0;
 	if (*ptr == ' ')
-		patch->new_mode = patch->old_mode = strtoul(ptr+1, NULL, 8);
+		patch->old_mode = strtoul(ptr+1, NULL, 8);
 	return 0;
 }
 
@@ -2447,6 +2447,7 @@ static int check_preimage(struct patch *patch, struct cache_entry **ce, struct s
 	if (st_mode != patch->old_mode)
 		fprintf(stderr, "warning: %s has type %o, expected %o\n",
 			old_name, st_mode, patch->old_mode);
+	patch->new_mode = st_mode;
 	return 0;
 
  is_new:
-- 
1.6.0.6